from ti_graphics import *

sgn = lambda n:(-1,1)[abs(n) == n]

def rec(name, base, defaut = None):
  try:
    return base[name]
  except:
    return defaut

def fill_auto(x,y,color,param):
  if param == "squared":
    if not ((x-y)%2):setPixel(x,y,color)
  elif param == "full":
    setPixel(x,y,color)
  elif param == "opaque":
    setPixel(x,y,(248,255,248))

def circle(x_c, y_c, r, color = (0,0,0)):
  setColor(color)
  drawArc(x_c - r, y_c - r, 2 * r, 2 * r, 0, 3600)

def line(x1, y1, x2, y2, color=(0,0,0)):
  drawLine(x1, y1, x2, y2, color)
    
def polygon(*coord, **kwargs):
  color = rec("color", kwargs, (0,0,0))
  fill = rec("fill", kwargs, None)
  setColor(color)
  if fill: fillPolygon(coord)
  else: drawPolyLine(coord)
        
def progress_bar(x,y,long,larg,prct,color = (0,255,0)):
  polygon((x,y),(x+long,y),(x+long,y+larg),(x,y+larg))
  line(x+2,y+larg+1,x+long+1,y+larg+1,(200,200,200))
  line(x+long+1,y+2,x+long+1,y+larg+1,(200,200,200))
  prct = int((long*prct)/100)-1
  if prct < 0:prct = 1
  for i in range(1,larg):
    line(1+x,y+i,x+prct,y+i,(color[0]-7*i,color[1]-7*i,color[2]-7*i))

def rectangle(x,y,long,larg,**kwargs):
  fill = rec("fill", kwargs, None)
  color = rec("color", kwargs, (0,0,0))
  setColor(color)
  if fill: fillRect(x, y, long, larg)
  else: drawRect(x, y, long, larg)
